#include <ctype.h>
#include <unistd.h>

static int
_strlen(char *s){
	int i;

	for(i = 0; s[i] != '\0'; ++i);

	return i;
}

int
fdprint(int fd, char *s){
	write(fd, s, _strlen(s));
}

/* SLOW. DO NOT USE. */
static int write1(int fd, int c){
	while(write(fd, &c, 1) != 1);
	return 1;
}

int fdputd(int fd, int d){
	int r;
	int s;

	r = 0;
	/* Just an implementation looking for a math person to improve it... */
	if(d < 100){
		s = d < 10 ? 1 : 10;
		goto put;
	}
	for(s = 10; d > (s *= 10););
put:	while(s > 0){
		r += write1(1, (d - (d % s)) / s + '0');
		if((s /= 10) == 0)
			r += write1(1, '\n');
	}
}

int
fdputs(int fd, char *s){
	int i;
	int r;

	i = _strlen(s);
	r = 0;

	/* RACE CONDITION */
	/* This leaves s as an invalid string while the write(2) syscall is
	 * performed, which can take a non-trivial amount of time. This
	 * implementation is unsuitable when s is shared between threads or
	 * whatever the CS term for that is. */
	s[i] = '\n';
	for(
		r = 0;
		(r += write(fd, s, i + 1)) < i + 1;
		s += r, i -= r
	);
	s[i] = '\0';

	return r;
}

/* Another possible implementation would take char **s and leave *s at the next
 * non-digit. But that's less simple; just while(isdigit(*s)) ++s;. */
unsigned int
parse_uint(char *s){
	unsigned int r;
	for(
		r = 0;
		isdigit(*s);
		r = r * 10 + *s - '0',
			++s
	);
	return r;
}
