/* There's already an excellent and popular XML library, libxml2, that
 * accomplishes what this does but better. Use that instead. */

#define XML_LEFT_BRACKET '<'
#define XML_RIGHT_BRACKET '>'
#define XML_FORWARD_SLASH '/'

struct XMLAttribute{
	char *name;
	char *content;
}

struct XMLDoc{
	struct XMLNode **nodes;
}

struct XMLNode{
	char *name;
	char *content;
	union{
		struct XMLDoc *doc;
		struct XMLNode *node;
	}parent;
	enum{
		XML_PARENT_IS_DOC = 0,
		XML_PARENT_IS_NODE = 1
	}parent_type;
	struct XMLAttribute **attributes;
	struct XMLNode **children;
}
