int builtin_escape	(int, char **);
int builtin_init	(int, char **);
int builtin_jail	(int, char **);
int builtin_nethack	(int, char **);
int builtin_reassure	(int, char **);
int builtin_status	(int, char **);

struct {
	char *name;
	int (*f)(int, char **);
}builtins[] = {
	{"escape", builtin_escape},
	{"init", builtin_init},
	{"jail", builtin_jail},
	{"nethack", builtin_nethack},
	{"status", builtin_status}
};

int
builtin_escape(int argc, char **argv){
	char *s;

	if((s = getenv("SHELL")) == NULL){
		fdputs(1, "$SHELL seems to be empty. This is an OS error.\n");
	}else if(fork() == 0)
		execl(s, s, NULL);
	else
		wait(NULL);

	return 0;
}

int
builtin_init(int argc, char **argv){
	fdputs(1,"\
\
	A voice whispers to you. \"Play NetHack...\" (\"nethack\" [enter]).\n\
	What would you like to do?"
	);
	return 0;
}

int
builtin_jail(int argc, char **argv){
	printf("%s\n", argv[1]);
	if(argv[1] == NULL)
		fdputd(1, state.jailed);
	else if(strcmp(argv[1], "break") == 0 || strcmp(argv[1], "build") == 0)
		state.jailed = (argv[1][1] - 'r') / ('u' - 'r'); /* cheap */
	else
		return 1;
	return 0;
}

int
builtin_nethack(int argc, char **argv){
	char *a[2];
	if(fork() == 0){
		a[0] = nethack_name;
		a[1] = NULL;
		execvp("nethack", a);
	}else
		wait(NULL);
	
	return 0;
}

int
builtin_status(int argc, char **argv){
	fdputd(1, state.status);
	return 0;
}
